# `createType(prefix, suffixes, modulePrefix): `

Utility to help creating Redux action types for API request actions.

### Arguments
1. `prefix` (string): Action type base
2. `suffixes` (Array.<string> [optional]) Array of suffixes to use to make types. Default is `['_COMPLETED', '_SUCCEEDED', '_FAILED']`
3. `modulePrefix` (string [optional]) Name of module actions belong to. If none provided, no prefix is added to action types names.

### Returns
Object containing redux actions types prepared for HTTP request-response cycle

#### Examples

```js
import createTypes from 'ackee-frontend-toolkit/lib/helpers/actionTypes';

createTypes('REQUEST_FEED');
/* 
 * [
 *    'REQUEST_FEED',
 *    'REQUEST_FEED_SUCCEEDED',
 *    'REQUEST_FEED_FAILED',
 *    'REQUEST_FEED_COMPLETED',
 * ]
 */
 
 createTypes('REQUEST_FEED', ['YEAH', 'DAMN']);
/* 
 * [
 *    'REQUEST_FEED',
 *    'REQUEST_FEED_YEAH',
 *    'REQUEST_FEED_DAMN',
 * ]
 */

createTypes('REQUEST_FEED', undefined, 'Dogs');
/* 
 * [
 *    'Dogs/REQUEST_FEED',
 *    'Dogs/REQUEST_FEED_SUCCEEDED',
 *    'Dogs/REQUEST_FEED_FAILED',
 *    'Dogs/REQUEST_FEED_COMPLETED',
 * ]
 */
```
