# `errorSaga(errorHandler?: function): void`

Used to handle error actions invoked from api calls created by [routing saga](./routing.md).
Just to don't let api call errors been swallowed.

#### Examples

Just use it as your only saga, or in list of sagas.

```js
import { errorSaga } from 'ackee-frontend-toolkit/sagas';

function* handleError({ error }) {
    console.log(error);
}

// main saga
export default function* () {
    yield all([
        // ... other sagas
        errorSaga(), // logs warning with error message into console
        // or
        errorSaga(handleError),
    ]);
}
```
