import React from 'react';
import { connect } from 'react-redux';
import { authUser } from 'ackee-redux-token-auth';
import { PropTypes } from 'prop-types';

import getDisplayName from '../helpers/componentName';

import { getTokens } from '../helpers/auth';

var MockAppLoader = function MockAppLoader() {
    return React.createElement(
        'div',
        null,
        'MockAppLoader'
    );
};

var authorizable = function authorizable(AuthorizableComponent, Firewall) {
    var Loader = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : MockAppLoader;

    var AuthorizedComponent = function AuthorizedComponent(props) {
        var tokens = getTokens();

        if (props.user) {
            return React.createElement(AuthorizableComponent, props);
        } else if (tokens) {
            return React.createElement(Loader, null);
        }
        return React.createElement(Firewall, null);
    };

    AuthorizedComponent.displayName = 'Authorizable(' + getDisplayName(AuthorizableComponent) + ')';
    AuthorizedComponent.propTypes = {
        // eslint-disable-next-line react/forbid-prop-types
        user: PropTypes.object
    };
    AuthorizedComponent.defaultProps = {
        user: null
    };

    return connect(function (state) {
        return {
            user: authUser(state)
        };
    })(AuthorizedComponent);
};

export default authorizable;