import { connect, bindActionCreators, submitFormAction, compose, reduxForm } from '../dependencies';

import * as actions from '../services/actions';
import constants from '../services/constants';

import MessageForm from '../components/Messages/MessageForm';

var mapStateToProps = function mapStateToProps(state, _ref) {
    var userId = _ref.userId,
        conversationId = _ref.conversationId;
    return {
        initialValues: {
            userId: userId,
            conversationId: conversationId
        }
    };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
    return {
        actions: bindActionCreators(actions, dispatch),
        onSubmit: bindActionCreators(submitFormAction(constants.NEW_MESSAGE_FORM_ID, actions.createMessage), dispatch)
    };
};

export default compose(connect(mapStateToProps, mapDispatchToProps), reduxForm({
    form: constants.NEW_MESSAGE_FORM_ID,
    enableReinitialize: true,
    destroyOnUnmount: false
}))(MessageForm);