import { firebaseConnect } from 'react-redux-firebase';

import { userConversations, users, conversationMessages, conversation, populates } from './paths';

export var userConversationsConnect = firebaseConnect(function (props) {
    return [{
        path: userConversations(props.userId).path,
        populates: populates.conversations
    }, users().path];
});

export var conversationMessagesConnect = firebaseConnect(function (_ref) {
    var conversationId = _ref.conversationId,
        count = _ref.count,
        disabledPaging = _ref.disabledPaging;
    return [conversationId && {
        path: conversationMessages(conversationId).path,
        populates: populates.messages,
        queryParams: disabledPaging ? [] : ['limitToLast=' + count]
    }].filter(function (path) {
        return !!path;
    });
});

export var conversationConnect = firebaseConnect(function (props) {
    return [conversation(props.id).path];
});