var chatPathBase = 'chat/';
var chatBase = 'chat.';

export var user = function user(userId) {
    return {
        path: '/' + chatPathBase + 'users/' + userId,
        store: chatBase + 'users.' + userId
    };
};

export var users = function users() {
    return {
        path: chatPathBase + 'users',
        store: chatBase + 'users'
    };
};

export var conversation = function conversation(conversationId) {
    return {
        path: '/' + chatPathBase + 'conversations/' + conversationId,
        store: chatBase + 'conversations.' + conversationId,
        id: chatPathBase + 'conversations/' + conversationId
    };
};

export var conversationMessages = function conversationMessages(conversationId) {
    return {
        path: '/' + chatPathBase + 'messages/' + conversationId,
        store: chatBase + 'messages.' + conversationId,
        id: chatPathBase + 'messages/' + conversationId
    };
};

export var conversationLastMessage = function conversationLastMessage(conversationId) {
    return {
        path: '/' + chatPathBase + 'conversations/' + conversationId + '/lastMessage',
        store: chatBase + 'conversations.' + conversationId + '.lastMessage'
    };
};

export var userConversation = function userConversation(userId, conversationId) {
    return {
        path: '/' + chatPathBase + 'usersConversations/' + userId + '/' + conversationId,
        store: chatBase + 'usersConversations.' + userId + '.' + conversationId
    };
};

export var userConversations = function userConversations(userId) {
    return {
        path: '/' + chatPathBase + 'usersConversations/' + userId,
        store: chatBase + 'usersConversations.' + userId,
        id: chatPathBase + 'usersConversations/' + userId
    };
};

export var populates = {
    conversations: [{
        child: 'conversation',
        root: chatPathBase + 'conversations',
        keyProp: 'id'
    }],
    messages: [{ child: 'author', root: chatPathBase + 'users', keyProp: 'authorId' }]
};