var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import { LOCATION_CHANGE } from 'react-router-redux';
import types from '../actionTypes';

var initialState = {
    page: 1,
    amount: 5,
    sentMessages: 0,
    firstUnreadMessageId: null
};

export default function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var action = arguments[1];

    switch (action.type) {
        case types.INC_CHAT:
            {
                var page = state.page + 1;
                return _extends({}, state, {
                    page: page
                });
            }
        case types.INC_SENT_MESSAGES:
            {
                var sentMessages = state.sentMessages + 1;
                return _extends({}, state, {
                    sentMessages: sentMessages
                });
            }
        case types.CONVERSATION_MESSAGES_LOADED:
            return _extends({}, state, {
                firstUnreadMessageId: action.firstUnreadMessageId
            });
        case types.CONVERSATION_LEAVE:
            return _extends({}, state, {
                firstUnreadMessageId: null
            });
        case LOCATION_CHANGE:
            return initialState;
        default:
            return state;
    }
}