var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { reducer as form } from 'redux-form';
import configureStore from '../../../../stories/configureStore';
import { reducer as chatReducer, constants as chatConstants, actionTypes as chatActionTypes } from '..';

import { firebaseData } from './chatData';

var fakeFirebaseReducer = function fakeFirebaseReducer() {
    var s = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : firebaseData;
    var action = arguments[1];

    switch (action.type) {
        case 'fb_requesting':
            return _extends({}, s, {
                requesting: _defineProperty({}, 'chat/' + action.dataPath, action.requesting)
            });
        case 'fb_requested':
            return _extends({}, s, {
                requested: _defineProperty({}, 'chat/' + action.dataPath, action.requested)
            });
        default:
            return s;
    }
};

var state = {
    chat: {
        page: 1,
        amount: 5,
        sentMessages: 0,
        firstUnreadMessageId: '-L7U1C3aNgrVDHKD_75h'
    },
    firebase: firebaseData
};

var reducers = {
    form: form,
    chat: chatReducer,
    firebase: fakeFirebaseReducer
};

var setRequestingAction = function setRequestingAction(dataPath, requesting) {
    return {
        type: 'fb_requesting',
        dataPath: dataPath,
        requesting: requesting
    };
};

var logMessageFormActions = function logMessageFormActions() {
    return function (next) {
        return function (action) {
            if (action.type === 'FORM_SUBMIT' && action.form === chatConstants.NEW_MESSAGE_FORM_ID) {
                var additionalInfo = 'for conversation ' + action.data.conversationId + ' and user ' + action.data.userId;
                // eslint-disable-next-line no-console
                console.info('SENDING CHAT MESSAGE ', '"' + action.data.text + '"', additionalInfo);
            }

            if (action.type === chatActionTypes.CREATE_IMAGE_MESSAGE) {
                var _additionalInfo = 'for conversation ' + action.data.conversationId + ' and user ' + action.data.userId;
                // eslint-disable-next-line no-console
                console.info('SENDING CHAT IMAGE', action.image, _additionalInfo);
            }

            next(action);
        };
    };
};

var store = configureStore(state, reducers, logMessageFormActions);

// eslint-disable-next-line import/prefer-default-export
export { store, setRequestingAction };