import React from 'react';
import * as PropTypes from 'prop-types';
import { reduxForm } from 'redux-form';

import Button from 'antd/lib/button';

var Form = function Form(_ref) {
    var handleSubmit = _ref.handleSubmit,
        children = _ref.children;
    return React.createElement(
        'form',
        { style: { padding: '2em' }, onSubmit: handleSubmit },
        children,
        React.createElement(
            Button,
            { type: 'primary', htmlType: 'submit' },
            'Submit'
        )
    );
};

Form.propTypes = {
    handleSubmit: PropTypes.func.isRequired,
    children: PropTypes.oneOfType([PropTypes.array, PropTypes.element, PropTypes.func, PropTypes.node]).isRequired
};

export default reduxForm({
    form: 'fieldStoriesForm',
    onSubmit: function onSubmit(data) {
        return console.log({ data: data });
    }
})(Form);