import { React, PropTypes, connect, IntlProvider, LocaleProvider } from '../dependencies';

import { getDisplayName } from '../../../helpers';

import { translateSelector } from '../services/selectors';

var translatable = function translatable(intlLocaleData, antdLocaleData) {
    return function (TranslatableComponent) {
        var Component = function Component(props) {
            return React.createElement(
                IntlProvider,
                {
                    locale: props.locale,
                    key: props.locale,
                    messages: intlLocaleData[props.locale]
                },
                React.createElement(
                    LocaleProvider,
                    { locale: antdLocaleData[props.locale] },
                    React.createElement(TranslatableComponent, props)
                )
            );
        };

        Component.displayName = 'Translatable(' + getDisplayName(TranslatableComponent) + ')';
        Component.propTypes = {
            locale: PropTypes.string.isRequired
        };

        return connect(function (state) {
            return translateSelector(state);
        })(Component);
    };
};

export default translatable;