function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

import 'babel-polyfill';
import React from 'react';
import PropTypes from 'prop-types';
import { createStore } from 'redux';
import { FormattedMessage, addLocaleData } from 'react-intl';
import cs from 'react-intl/locale-data/cs';
import cs_CZ from 'antd/lib/locale-provider/cs_CZ';
import en_US from 'antd/lib/locale-provider/en_US';

import { Pagination } from 'antd';

import { storiesOf } from '@storybook/react';

import 'antd/es/pagination/style/index.less';

import { translatableHOC as translatable } from '..';

addLocaleData([].concat(_toConsumableArray(cs)));

var messages = {
    cs: {
        foo: 'Ano, ja jsem foo',
        'bar.baz': 'Ne, ja jsem bar baz'
    },
    en: {
        foo: 'Yeah, I am foo',
        'bar.baz': 'No, I am baz'
    }
};

var antdLocales = {
    cs: cs_CZ,
    en: en_US
};

var initialState = {
    translate: { locale: 'cs' }
};
var store = createStore(function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var action = arguments[1];

    if (action.type === 'CHANGE_LOCALE') {
        return {
            translate: { locale: action.locale }
        };
    }
    return state;
});

var localeChangeHandler = function localeChangeHandler(e) {
    return store.dispatch({ type: 'CHANGE_LOCALE', locale: e.target.value });
};

var ContentComponent = function ContentComponent(_ref) {
    var locale = _ref.locale;
    return React.createElement(
        'div',
        null,
        ['cs', 'en'].map(function (lang) {
            return React.createElement(
                'div',
                { key: lang },
                lang,
                ' ',
                React.createElement('input', {
                    type: 'radio',
                    name: 'locale',
                    value: lang,
                    checked: lang === locale,
                    onChange: localeChangeHandler
                })
            );
        }),
        React.createElement(Pagination, { defaultCurrent: 1, total: 50, showSizeChanger: true }),
        React.createElement(
            'h1',
            null,
            React.createElement(FormattedMessage, { id: 'foo' })
        ),
        React.createElement(
            'h2',
            null,
            React.createElement(FormattedMessage, { id: 'bar.baz' })
        )
    );
};

ContentComponent.propTypes = {
    locale: PropTypes.string.isRequired
};

storiesOf('Modules|localization/translatable', module).add('simple', function () {
    var TranslatableComponent = translatable(messages, antdLocales)(ContentComponent);
    return React.createElement(TranslatableComponent, { store: store });
});