'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _ackeeReduxTokenAuth = require('ackee-redux-token-auth');

var _propTypes = require('prop-types');

var _componentName = require('../helpers/componentName');

var _componentName2 = _interopRequireDefault(_componentName);

var _auth = require('../helpers/auth');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MockAppLoader = function MockAppLoader() {
    return _react2.default.createElement(
        'div',
        null,
        'MockAppLoader'
    );
};

var authorizable = function authorizable(AuthorizableComponent, Firewall) {
    var Loader = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : MockAppLoader;

    var AuthorizedComponent = function AuthorizedComponent(props) {
        var tokens = (0, _auth.getTokens)();

        if (props.user) {
            return _react2.default.createElement(AuthorizableComponent, props);
        } else if (tokens) {
            return _react2.default.createElement(Loader, null);
        }
        return _react2.default.createElement(Firewall, null);
    };

    AuthorizedComponent.displayName = 'Authorizable(' + (0, _componentName2.default)(AuthorizableComponent) + ')';
    AuthorizedComponent.propTypes = {
        // eslint-disable-next-line react/forbid-prop-types
        user: _propTypes.PropTypes.object
    };
    AuthorizedComponent.defaultProps = {
        user: null
    };

    return (0, _reactRedux.connect)(function (state) {
        return {
            user: (0, _ackeeReduxTokenAuth.authUser)(state)
        };
    })(AuthorizedComponent);
};

exports.default = authorizable;