'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _componentName = require('../helpers/componentName');

var _componentName2 = _interopRequireDefault(_componentName);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function loadableFactory(LoaderComponent) {
    return function (LoadableComponent, text) {
        var ComponentWithLoader = function ComponentWithLoader(props) {
            return _react2.default.createElement(
                LoaderComponent,
                { show: props.showLoader, text: text },
                _react2.default.createElement(LoadableComponent, _lodash2.default.omit(props, ['children', 'showLoader']))
            );
        };

        ComponentWithLoader.displayName = 'Loadable(' + (0, _componentName2.default)(LoadableComponent) + ')';
        ComponentWithLoader.propTypes = {
            showLoader: _propTypes2.default.bool.isRequired
        };

        return ComponentWithLoader;
    };
}

exports.default = loadableFactory;