'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.getTokens = getTokens;
exports.setTokens = setTokens;
exports.clearTokens = clearTokens;
exports.updateTokens = updateTokens;
function getTokens() {
    if (localStorage) {
        return JSON.parse(localStorage.getItem('tokens'));
    }
    return null;
}

function setTokens(tokens) {
    if (localStorage) {
        localStorage.setItem('tokens', JSON.stringify(tokens));
    }
}

function clearTokens() {
    if (localStorage) {
        localStorage.removeItem('tokens');
    }
}

function updateTokens(tokens) {
    var prevTokens = getTokens();

    setTokens(_extends({}, prevTokens, tokens));
}