'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _dependencies = require('../../dependencies');

var _Messages = require('../../containers/Messages');

var _Messages2 = _interopRequireDefault(_Messages);

var _MessageForm = require('../../containers/MessageForm');

var _MessageForm2 = _interopRequireDefault(_MessageForm);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Conversation = function Conversation(_ref) {
    var userId = _ref.userId,
        conversationId = _ref.conversationId,
        isLoaded = _ref.isLoaded,
        header = _ref.header,
        loader = _ref.loader,
        filesEnabled = _ref.filesEnabled,
        sendLabel = _ref.sendLabel,
        uploadLabel = _ref.uploadLabel,
        MessageAuthor = _ref.MessageAuthor,
        MessageImage = _ref.MessageImage,
        MessageComponent = _ref.MessageComponent,
        newMessageInput = _ref.newMessageInput,
        newMessageInputProps = _ref.newMessageInputProps;
    return _dependencies.React.createElement(
        'div',
        { className: 'conversation' },
        isLoaded && _dependencies.React.createElement(
            _dependencies.React.Fragment,
            null,
            header,
            _dependencies.React.createElement(_Messages2.default, {
                userId: userId,
                conversationId: conversationId,
                MessageAuthor: MessageAuthor,
                MessageImage: MessageImage,
                MessageComponent: MessageComponent
            }),
            _dependencies.React.createElement(_MessageForm2.default, {
                userId: userId,
                conversationId: conversationId,
                filesEnabled: filesEnabled,
                sendLabel: sendLabel,
                uploadLabel: uploadLabel,
                newMessageInput: newMessageInput,
                newMessageInputProps: newMessageInputProps
            })
        ),
        !isLoaded && loader
    );
};

Conversation.propTypes = {
    conversationId: _dependencies.PropTypes.string.isRequired,
    userId: _dependencies.PropTypes.string.isRequired,
    isLoaded: _dependencies.PropTypes.bool.isRequired,
    header: _dependencies.PropTypes.node,
    loader: _dependencies.PropTypes.node,
    // message form customization props
    filesEnabled: _dependencies.PropTypes.bool,
    sendLabel: _dependencies.PropTypes.node,
    uploadLabel: _dependencies.PropTypes.node,
    newMessageInput: _dependencies.PropTypes.node,
    newMessageInputProps: _dependencies.PropTypes.shape(),
    // messages customization props
    MessageAuthor: _dependencies.PropTypes.func,
    MessageImage: _dependencies.PropTypes.func,
    MessageComponent: _dependencies.PropTypes.func
};

Conversation.defaultProps = {
    conversation: {},
    header: null,
    loader: _dependencies.React.createElement(_dependencies.FormattedMessage, { id: 'chat.conversation.loading' }),
    filesEnabled: undefined,
    sendLabel: undefined,
    uploadLabel: undefined,
    newMessageInput: undefined,
    newMessageInputProps: undefined,
    MessageAuthor: undefined,
    MessageImage: undefined,
    MessageComponent: undefined
};

exports.default = Conversation;