'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _dependencies = require('../../dependencies');

var _SearchForm = require('../../containers/SearchForm');

var _SearchForm2 = _interopRequireDefault(_SearchForm);

var _ConversationsItem = require('./ConversationsItem');

var _ConversationsItem2 = _interopRequireDefault(_ConversationsItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Conversations = function Conversations(_ref) {
    var userId = _ref.userId,
        conversations = _ref.conversations,
        isLoaded = _ref.isLoaded,
        loader = _ref.loader,
        visible = _ref.visible,
        searchEnabled = _ref.searchEnabled,
        searchLabel = _ref.searchLabel,
        ConversationsItem = _ref.ConversationsItem,
        noDataMessage = _ref.noDataMessage;
    return _dependencies.React.createElement(
        'div',
        {
            className: (0, _dependencies.classnames)('conversations', {
                'conversations--hidden': !visible
            })
        },
        searchEnabled && _dependencies.React.createElement(_SearchForm2.default, { searchLabel: searchLabel }),
        !isLoaded ? loader : _dependencies.React.createElement(_dependencies.DataList, {
            data: conversations,
            RowComponent: _dependencies.React.createElement(_ConversationsItem2.default, { userId: userId, ContentComponent: ConversationsItem }),
            noDataMessage: noDataMessage,
            element: 'ul'
        })
    );
};

Conversations.propTypes = {
    userId: _dependencies.PropTypes.string.isRequired,
    ConversationsItem: _dependencies.PropTypes.func.isRequired,
    conversations: _dependencies.PropTypes.arrayOf(_dependencies.PropTypes.shape({})),
    isLoaded: _dependencies.PropTypes.bool.isRequired,
    visible: _dependencies.PropTypes.bool,
    searchEnabled: _dependencies.PropTypes.bool,
    searchLabel: _dependencies.PropTypes.node,
    loader: _dependencies.PropTypes.node,
    noDataMessage: _dependencies.PropTypes.node
};

Conversations.defaultProps = {
    conversations: [],
    visible: true,
    searchEnabled: false,
    searchLabel: null,
    loader: _dependencies.React.createElement(_dependencies.FormattedMessage, { id: 'chat.conversations.loading' }),
    noDataMessage: _dependencies.React.createElement(_dependencies.FormattedMessage, { id: 'chat.conversations.noData' })
};

exports.default = (0, _dependencies.pure)()(Conversations);