'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _dependencies = require('../../dependencies');

var _constants = require('../../services/constants');

var _constants2 = _interopRequireDefault(_constants);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SearchForm = function SearchForm(_ref) {
    var handleSubmit = _ref.handleSubmit,
        intl = _ref.intl,
        pristine = _ref.pristine,
        submitting = _ref.submitting,
        searchLabel = _ref.searchLabel;
    return _dependencies.React.createElement(
        'div',
        { className: 'conversations__search-form' },
        _dependencies.React.createElement(
            _dependencies.Form,
            { className: 'form', onSubmit: handleSubmit },
            _dependencies.React.createElement(_dependencies.Field, {
                name: 'text',
                type: 'text',
                component: 'input',
                placeholder: intl.formatMessage({
                    id: 'chat.conversations.search.placeholder'
                })
            }),
            searchLabel && _dependencies.React.createElement(
                'button',
                { disabled: pristine || submitting, type: 'submit' },
                searchLabel
            )
        )
    );
};

SearchForm.propTypes = {
    handleSubmit: _dependencies.PropTypes.func.isRequired,
    intl: _dependencies.PropTypes.shape({
        formatMessage: _dependencies.PropTypes.func
    }).isRequired,
    pristine: _dependencies.PropTypes.bool.isRequired,
    submitting: _dependencies.PropTypes.bool.isRequired,
    searchLabel: _dependencies.PropTypes.node
};

SearchForm.defaultProps = {
    searchLabel: null
};

exports.default = (0, _dependencies.compose)(_dependencies.injectIntl, (0, _dependencies.reduxForm)({
    form: _constants2.default.SEARCH_CONVERSATION_FORM_ID
}))(SearchForm);