'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dependencies = require('../../dependencies');

var _Message = require('./Message');

var _Message2 = _interopRequireDefault(_Message);

var _LoadMoreButton = require('../LoadMoreButton');

var _LoadMoreButton2 = _interopRequireDefault(_LoadMoreButton);

var _UnseenSeparator = require('./UnseenSeparator');

var _UnseenSeparator2 = _interopRequireDefault(_UnseenSeparator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var rootElementId = 'conversation__messages';

var Messages = function (_React$Component) {
    _inherits(Messages, _React$Component);

    function Messages() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, Messages);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Messages.__proto__ || Object.getPrototypeOf(Messages)).call.apply(_ref, [this].concat(args))), _this), _this.handleLoadMore = function () {
            var incChatPage = _this.props.incChatPage;
            var _this$props = _this.props,
                messagesCount = _this$props.messagesCount,
                messages = _this$props.messages;

            if (messages.length < messagesCount) {
                incChatPage();
            }
        }, _this.renderMessage = function (message) {
            var _this$props2 = _this.props,
                conversationId = _this$props2.conversationId,
                MessageAuthor = _this$props2.MessageAuthor,
                MessageImage = _this$props2.MessageImage,
                MessageComponent = _this$props2.MessageComponent;


            return _dependencies.React.createElement(MessageComponent, _extends({}, message, {
                key: message.messageId,
                conversationId: conversationId,
                MessageAuthor: MessageAuthor,
                MessageImage: MessageImage
            }));
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(Messages, [{
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps) {
            var _props = this.props,
                conversationId = _props.conversationId,
                isLoaded = _props.isLoaded,
                messages = _props.messages,
                conversationMessagesLoaded = _props.conversationMessagesLoaded;


            var last = (0, _dependencies._last)(prevProps.messages) || {};
            var lastNew = (0, _dependencies._last)(messages) || {};

            if (prevProps.unseenMessagesCount !== this.props.unseenMessagesCount || prevProps.sentMessagesCount !== this.props.sentMessagesCount || last.messageId !== lastNew.messageId) {
                Messages.scrollToBottom();
            }

            if (!prevProps.isLoaded && isLoaded) {
                var unseenMessagesCount = Math.max(0, this.props.unseenMessagesCount);
                var firstUnseenMessage = messages[messages.length - unseenMessagesCount];

                conversationMessagesLoaded(conversationId, (0, _dependencies._get)(firstUnseenMessage, 'messageId', null));
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _props2 = this.props,
                messagesCount = _props2.messagesCount,
                isLoaded = _props2.isLoaded,
                isEmpty = _props2.isEmpty,
                messages = _props2.messages,
                readMessagesCount = _props2.readMessagesCount,
                loader = _props2.loader,
                noDataMessage = _props2.noDataMessage;

            var unseenMessagesCount = Math.max(0, this.props.unseenMessagesCount);

            var readMessages = messages.slice(0, readMessagesCount);
            var unreadMessages = messages.slice(readMessagesCount);

            return _dependencies.React.createElement(
                'div',
                { id: rootElementId, className: 'conversation__messages' },
                isLoaded && !isEmpty && _dependencies.React.createElement(
                    _dependencies.React.Fragment,
                    null,
                    _dependencies.React.createElement(
                        'div',
                        { className: 'conversation__messages-loader' },
                        _dependencies.React.createElement(_LoadMoreButton2.default, {
                            disabled: messages.length >= messagesCount,
                            onClick: this.handleLoadMore
                        })
                    ),
                    readMessages.map(this.renderMessage)
                ),
                isLoaded && readMessagesCount < messages.length && _dependencies.React.createElement(_UnseenSeparator2.default, { unseen: unseenMessagesCount }),
                isLoaded && !isEmpty && unreadMessages.map(this.renderMessage),
                !isLoaded && loader,
                isLoaded && isEmpty && noDataMessage
            );
        }
    }], [{
        key: 'scrollToBottom',
        value: function scrollToBottom() {
            var div = document.getElementById(rootElementId);
            div.scrollTop = div.scrollHeight - div.clientHeight;
        }
    }]);

    return Messages;
}(_dependencies.React.Component);

Messages.propTypes = {
    // userId and conversationId are used by container, but since they're important
    // props, we're typechecking them here
    userId: _dependencies.PropTypes.string.isRequired,
    conversationId: _dependencies.PropTypes.string.isRequired,

    messagesCount: _dependencies.PropTypes.number,
    unseenMessagesCount: _dependencies.PropTypes.number,
    isLoaded: _dependencies.PropTypes.bool.isRequired,
    isEmpty: _dependencies.PropTypes.bool.isRequired,
    messages: _dependencies.PropTypes.arrayOf(_dependencies.PropTypes.shape({
        messageId: _dependencies.PropTypes.string.isRequired,
        author: _Message.authorShape,
        text: _dependencies.PropTypes.string,
        time: _dependencies.PropTypes.number
    })),
    sentMessagesCount: _dependencies.PropTypes.number.isRequired,
    loader: _dependencies.PropTypes.node,
    incChatPage: _dependencies.PropTypes.func.isRequired,
    conversationMessagesLoaded: _dependencies.PropTypes.func.isRequired,
    readMessagesCount: _dependencies.PropTypes.number.isRequired,
    MessageAuthor: _dependencies.PropTypes.func,
    MessageImage: _dependencies.PropTypes.func,
    MessageComponent: _dependencies.PropTypes.func,
    noDataMessage: _dependencies.PropTypes.node
};
Messages.defaultProps = {
    messagesCount: 0,
    unseenMessagesCount: 0,
    messages: [],
    loader: _dependencies.React.createElement(
        'span',
        { className: 'conversation__loading' },
        _dependencies.React.createElement(_dependencies.FormattedMessage, { id: 'chat.messages.loading' })
    ),
    MessageAuthor: undefined,
    MessageImage: undefined,
    MessageComponent: _Message2.default,
    noDataMessage: _dependencies.React.createElement(
        'span',
        { className: 'conversation__no-messages' },
        _dependencies.React.createElement(_dependencies.FormattedMessage, { id: 'chat.messages.noData' })
    )
};
exports.default = (0, _dependencies.pure)()(Messages);