'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
var chatPathBase = 'chat/';
var chatBase = 'chat.';

var user = exports.user = function user(userId) {
    return {
        path: '/' + chatPathBase + 'users/' + userId,
        store: chatBase + 'users.' + userId
    };
};

var users = exports.users = function users() {
    return {
        path: chatPathBase + 'users',
        store: chatBase + 'users'
    };
};

var conversation = exports.conversation = function conversation(conversationId) {
    return {
        path: '/' + chatPathBase + 'conversations/' + conversationId,
        store: chatBase + 'conversations.' + conversationId,
        id: chatPathBase + 'conversations/' + conversationId
    };
};

var conversationMessages = exports.conversationMessages = function conversationMessages(conversationId) {
    return {
        path: '/' + chatPathBase + 'messages/' + conversationId,
        store: chatBase + 'messages.' + conversationId,
        id: chatPathBase + 'messages/' + conversationId
    };
};

var conversationLastMessage = exports.conversationLastMessage = function conversationLastMessage(conversationId) {
    return {
        path: '/' + chatPathBase + 'conversations/' + conversationId + '/lastMessage',
        store: chatBase + 'conversations.' + conversationId + '.lastMessage'
    };
};

var userConversation = exports.userConversation = function userConversation(userId, conversationId) {
    return {
        path: '/' + chatPathBase + 'usersConversations/' + userId + '/' + conversationId,
        store: chatBase + 'usersConversations.' + userId + '.' + conversationId
    };
};

var userConversations = exports.userConversations = function userConversations(userId) {
    return {
        path: '/' + chatPathBase + 'usersConversations/' + userId,
        store: chatBase + 'usersConversations.' + userId,
        id: chatPathBase + 'usersConversations/' + userId
    };
};

var populates = exports.populates = {
    conversations: [{
        child: 'conversation',
        root: chatPathBase + 'conversations',
        keyProp: 'id'
    }],
    messages: [{ child: 'author', root: chatPathBase + 'users', keyProp: 'authorId' }]
};