'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var action = arguments[1];

    switch (action.type) {
        case _actionTypes2.default.INC_CHAT:
            {
                var page = state.page + 1;
                return _extends({}, state, {
                    page: page
                });
            }
        case _actionTypes2.default.INC_SENT_MESSAGES:
            {
                var sentMessages = state.sentMessages + 1;
                return _extends({}, state, {
                    sentMessages: sentMessages
                });
            }
        case _actionTypes2.default.CONVERSATION_MESSAGES_LOADED:
            return _extends({}, state, {
                firstUnreadMessageId: action.firstUnreadMessageId
            });
        case _actionTypes2.default.CONVERSATION_LEAVE:
            return _extends({}, state, {
                firstUnreadMessageId: null
            });
        case _reactRouterRedux.LOCATION_CHANGE:
            return initialState;
        default:
            return state;
    }
};

var _reactRouterRedux = require('react-router-redux');

var _actionTypes = require('../actionTypes');

var _actionTypes2 = _interopRequireDefault(_actionTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var initialState = {
    page: 1,
    amount: 5,
    sentMessages: 0,
    firstUnreadMessageId: null
};