'use strict';

require('babel-polyfill');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _reactIntl = require('react-intl');

var _react3 = require('@storybook/react');

var _DataLoadDelay = require('./DataLoadDelay');

var _DataLoadDelay2 = _interopRequireDefault(_DataLoadDelay);

var _ = require('../');

var _chatData = require('./chatData');

var _chat = require('./chat.envSetup');

require('./chatStories.scss');

require('../styles.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _react3.storiesOf)('Modules|chat/Conversation', module).addDecorator(function (story) {
    return _react2.default.createElement(
        _reactRedux.Provider,
        { store: _chat.store },
        _react2.default.createElement(
            _reactIntl.IntlProvider,
            { locale: 'en', messages: _chatData.intlMessages },
            _react2.default.createElement(
                'div',
                { className: 'panel messages-panel' },
                story()
            )
        )
    );
}).add('basic', function () {
    return _react2.default.createElement(_.Conversation, {
        conversationId: 'driver_1551',
        userId: 'dispatcher_9',
        sendLabel: 'Send it!'
    });
}).add('default loader', function () {
    return _react2.default.createElement(
        _DataLoadDelay2.default,
        {
            store: _chat.store,
            firebaseDataPath: 'messages/driver_1551',
            delay: 5000
        },
        _react2.default.createElement(_.Conversation, {
            conversationId: 'driver_1551',
            userId: 'dispatcher_9',
            sendLabel: 'Send it!'
        })
    );
}).add('custom loader', function () {
    return _react2.default.createElement(
        _DataLoadDelay2.default,
        {
            store: _chat.store,
            firebaseDataPath: 'messages/driver_1551'
        },
        _react2.default.createElement(_.Conversation, {
            conversationId: 'driver_1551',
            userId: 'dispatcher_9',
            sendLabel: 'Send it!',
            loader: _react2.default.createElement(
                'h1',
                { style: { textAlign: 'center' } },
                'Loading whole conversation'
            )
        })
    );
});