'use strict';

require('babel-polyfill');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _reactIntl = require('react-intl');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _react3 = require('@storybook/react');

var _DataLoadDelay = require('./DataLoadDelay');

var _DataLoadDelay2 = _interopRequireDefault(_DataLoadDelay);

var _2 = require('../');

var _chatData = require('./chatData');

var _chat = require('./chat.envSetup');

require('./chatStories.scss');

require('../styles.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SearchIcon = function SearchIcon() {
    return _react2.default.createElement(
        'svg',
        {
            width: '18px',
            height: '18px',
            viewBox: '0 0 18 18',
            version: '1.1',
            xmlns: 'http://www.w3.org/2000/svg'
        },
        _react2.default.createElement(
            'g',
            {
                id: 'Symbols',
                stroke: 'none',
                strokeWidth: '1',
                fill: 'none',
                fillRule: 'evenodd'
            },
            _react2.default.createElement(
                'g',
                { id: 'ic_search_24px', transform: 'translate(-3.000000, -3.000000)' },
                _react2.default.createElement('path', {
                    d: 'M15.5,14 L14.71,14 L14.43,13.73 C15.41,12.59 16,11.11 16,9.5 C16,5.91 13.09,3 9.5,3 C5.91,3 3,5.91 3,9.5 C3,13.09 5.91,16 9.5,16 C11.11,16 12.59,15.41 13.73,14.43 L14,14.71 L14,15.5 L19,20.49 L20.49,19 L15.5,14 Z M9.5,14 C7.01,14 5,11.99 5,9.5 C5,7.01 7.01,5 9.5,5 C11.99,5 14,7.01 14,9.5 C14,11.99 11.99,14 9.5,14 Z',
                    id: 'Shape',
                    fill: '#9BC111',
                    fillRule: 'nonzero'
                }),
                _react2.default.createElement('polygon', { id: 'Shape', points: '0 0 24 0 24 24 0 24' })
            )
        )
    );
};

var ConversationsItem = function ConversationsItem(_ref) {
    var userId = _ref.userId,
        conversationId = _ref.conversationId,
        users = _ref.users;
    return _react2.default.createElement(
        'div',
        { className: 'content' },
        conversationId,
        ' ',
        _lodash2.default.get(_lodash2.default.find(users, function (__, id) {
            return id !== userId;
        }), 'name')
    );
};

ConversationsItem.propTypes = {
    userId: _propTypes2.default.string.isRequired,
    conversationId: _propTypes2.default.string.isRequired,
    users: _propTypes2.default.objectOf(_propTypes2.default.shape({
        name: _propTypes2.default.string
    })).isRequired
};

(0, _react3.storiesOf)('Modules|chat/Conversations', module).addDecorator(function (story) {
    return _react2.default.createElement(
        _reactRedux.Provider,
        { store: _chat.store },
        _react2.default.createElement(
            _reactIntl.IntlProvider,
            { locale: 'en', messages: _chatData.intlMessages },
            _react2.default.createElement(
                'div',
                { className: 'panel conversations-list-panel' },
                story()
            )
        )
    );
}).add('basic', function () {
    return _react2.default.createElement(_2.Conversations, {
        ConversationsItem: ConversationsItem,
        userId: 'dispatcher_9'
    });
}).add('no data', function () {
    return _react2.default.createElement(_2.Conversations, { ConversationsItem: ConversationsItem, userId: 'dispatcher_8' });
}).add('default loader', function () {
    return _react2.default.createElement(
        _DataLoadDelay2.default,
        {
            store: _chat.store,
            firebaseDataPath: 'usersConversations/dispatcher_9'
        },
        _react2.default.createElement(_2.Conversations, { ConversationsItem: ConversationsItem, userId: 'dispatcher_9' })
    );
}).add('custom loader', function () {
    return _react2.default.createElement(
        _DataLoadDelay2.default,
        {
            store: _chat.store,
            firebaseDataPath: 'usersConversations/dispatcher_9'
        },
        _react2.default.createElement(_2.Conversations, {
            ConversationsItem: ConversationsItem,
            userId: 'dispatcher_9',
            loader: _react2.default.createElement(
                'h3',
                { style: { color: 'red', textAlign: 'center' } },
                'Loading conversations red...'
            )
        })
    );
}).add('custom no data message', function () {
    return _react2.default.createElement(_2.Conversations, {
        ConversationsItem: ConversationsItem,
        userId: 'dispatcher_8',
        noDataMessage: _react2.default.createElement(
            'h4',
            null,
            'Sorry, no conversations available'
        )
    });
}).add('with search bar', function () {
    return _react2.default.createElement(_2.Conversations, {
        ConversationsItem: ConversationsItem,
        userId: 'dispatcher_9',
        searchEnabled: true,
        searchLabel: _react2.default.createElement(SearchIcon, null)
    });
});