'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

require('babel-polyfill');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _reactIntl = require('react-intl');

var _react3 = require('@storybook/react');

var _ = require('../');

var _chatData = require('./chatData');

var _chat = require('./chat.envSetup');

require('./chatStories.scss');

require('../styles.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var UploadIcon = function UploadIcon() {
    return _react2.default.createElement(
        'svg',
        {
            version: '1.1',
            xmlns: 'http://www.w3.org/2000/svg',
            x: '0px',
            y: '0px',
            viewBox: '0 0 53.3 53.4'
        },
        _react2.default.createElement(
            'g',
            null,
            _react2.default.createElement('path', {
                d: 'M44.1,32.5c-0.6,0-1.2,0.5-1.2,1.2v8c0,0.1-0.1,0.1-0.2,0.1H10.6c-0.1,0-0.2-0.1-0.2-0.1v-8c0-0.6-0.5-1.2-1.2-1.2 C8.6,32.5,8,33,8,33.6v8c0,1.4,1.1,2.5,2.5,2.5h32.2c1.4,0,2.5-1.1,2.5-2.5v-8C45.3,33,44.7,32.5,44.1,32.5z'
            }),
            _react2.default.createElement('path', {
                d: 'M17.4,21.2l8-8v21c0,0.6,0.5,1.2,1.2,1.2c0.6,0,1.2-0.5,1.2-1.2v-21l8,8c0.2,0.2,0.5,0.3,0.8,0.3c0.3,0,0.6-0.1,0.8-0.3 c0.5-0.5,0.5-1.2,0-1.7l-10-10c-0.2-0.2-0.5-0.3-0.8-0.3c-0.3,0-0.6,0.1-0.8,0.3l-10,10c-0.5,0.5-0.5,1.2,0,1.7 C16.2,21.7,17,21.7,17.4,21.2z'
            })
        )
    );
};

var InputField = function InputField(_ref) {
    var label = _ref.label,
        id = _ref.id,
        input = _ref.input;
    return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        label ? _react2.default.createElement(
            'label',
            { htmlFor: id },
            label
        ) : null,
        _react2.default.createElement('input', _extends({ id: id }, input))
    );
};

InputField.propTypes = {
    label: _propTypes2.default.node.isRequired,
    id: _propTypes2.default.string.isRequired,
    input: _propTypes2.default.shape().isRequired
};

(0, _react3.storiesOf)('Modules|chat/MessageForm', module).addDecorator(function (story) {
    return _react2.default.createElement(
        _reactRedux.Provider,
        { store: _chat.store },
        _react2.default.createElement(
            _reactIntl.IntlProvider,
            { locale: 'en', messages: _chatData.intlMessages },
            _react2.default.createElement(
                'div',
                { className: 'panel messages-panel' },
                story()
            )
        )
    );
}).add('basic', function () {
    return _react2.default.createElement(_.MessageForm, {
        userId: 'dispatcher_9',
        conversationId: 'driver_1551',
        sendLabel: 'Send it!'
    });
}).add('custom input', function () {
    return _react2.default.createElement(_.MessageForm, {
        userId: 'dispatcher_9',
        conversationId: 'driver_1551',
        sendLabel: 'Send it!',
        newMessageInput: 'textarea'
    });
}).add('custom input properties', function () {
    return _react2.default.createElement(_.MessageForm, {
        userId: 'dispatcher_9',
        conversationId: 'driver_1551',
        sendLabel: 'Send it!',
        newMessageInput: InputField,
        newMessageInputProps: {
            label: 'FOOO',
            id: 'foo'
        }
    });
}).add('with sending files', function () {
    return _react2.default.createElement(_.MessageForm, {
        userId: 'dispatcher_9',
        conversationId: 'driver_1551',
        sendLabel: _react2.default.createElement(
            'strong',
            null,
            'Send it!'
        ),
        uploadLabel: _react2.default.createElement(
            'span',
            null,
            _react2.default.createElement(UploadIcon, null),
            'UPLOAD FILE..'
        ),
        filesEnabled: true
    });
});