'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.DatePickerInput = exports.TimePickerInput = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _dependencies = require('../../dependencies');

var pickerMap = (0, _dependencies.customMap)(function (mapProps, _ref) {
    var _ref$input = _ref.input,
        _onChange = _ref$input.onChange,
        value = _ref$input.value,
        error = _ref.meta.error,
        displayFormat = _ref.displayFormat;

    if (!displayFormat) {
        console.warn('Property displayFormat is not set. Always set the property to prevent bugs!');
    }
    var date = (0, _dependencies.moment)(value);
    return _extends({}, mapProps, {
        onChange: function onChange(_, v) {
            var val = (0, _dependencies.moment)(v, displayFormat);
            _onChange(val);
        },
        value: date.isValid() ? date : null,
        help: error,
        validateStatus: error ? 'error' : 'success',
        hasFeedback: false,
        format: displayFormat
    });
});

var picker = function picker(Picker) {
    return (0, _dependencies.createComponent)(Picker, pickerMap);
};

var TimePickerInput = picker(_dependencies.TimePicker);
var DatePickerInput = picker(_dependencies.DatePicker);

exports.TimePickerInput = TimePickerInput;
exports.DatePickerInput = DatePickerInput;
exports.default = picker;